Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java	(revision 84)
@@ -0,0 +1,9 @@
+package com.framsticks.util.dispatching;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public interface Dispatcher {
+    public boolean isActive();
+    public void invokeLater(Runnable runnable);
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 84)
@@ -0,0 +1,45 @@
+package com.framsticks.util.dispatching;
+
+import com.framsticks.util.StateFunctor;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class Dispatching {
+
+    public static boolean isThreadSafe() {
+        return true;
+    }
+
+    public static void invokeLaterOrNow(Dispatcher dispatcher, Runnable runnable) {
+        if (dispatcher.isActive()) {
+            runnable.run();
+            return;
+        }
+        dispatcher.invokeLater(runnable);
+    }
+
+    public static void dispatchOk(Dispatcher dispatcher, final StateFunctor stateFunctor) {
+        dispatcher.invokeLater(new Runnable() {
+            @Override
+            public void run() {
+                stateFunctor.call(null);
+            }
+        });
+    }
+
+    public static boolean assertInvokeLater(Dispatcher dispatcher, Runnable runnable) {
+        dispatcher.invokeLater(runnable);
+        return true;
+    }
+
+    public static void invokeDispatch(Dispatcher dispatcher, final Dispatcher finalDispatcher, final Runnable runnable) {
+        dispatcher.invokeLater(new Runnable() {
+            @Override
+            public void run() {
+                finalDispatcher.invokeLater(runnable);
+            }
+        });
+    }
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Future.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Future.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Future.java	(revision 84)
@@ -0,0 +1,8 @@
+package com.framsticks.util.dispatching;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public interface Future <T> {
+    void result(T result, Exception e);
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Task.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Task.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Task.java	(revision 84)
@@ -0,0 +1,22 @@
+package com.framsticks.util.dispatching;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class Task implements Runnable {
+
+    protected final long moment;
+
+    public Task() {
+        moment = System.currentTimeMillis();
+    }
+
+    public Task(long moment) {
+        this.moment = moment;
+    }
+
+    public final long getMoment() {
+        return moment;
+    }
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Thread.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 84)
@@ -0,0 +1,135 @@
+package com.framsticks.util.dispatching;
+
+import org.apache.log4j.Logger;
+
+import java.util.LinkedList;
+import java.util.ListIterator;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class Thread implements Dispatcher {
+
+	private static final Logger log = Logger.getLogger(Thread.class.getName());
+
+	protected final java.lang.Thread thread;
+
+	private final LinkedList<Task> queue = new LinkedList<Task>();
+
+	public Thread() {
+		thread = new java.lang.Thread(new Runnable() {
+			@Override
+			public void run() {
+				Thread.this.routine();
+			}
+		});
+	}
+	public Thread(String s) {
+		this();
+		thread.setName(s);
+		thread.start();
+	}
+
+	public Thread(String s, java.lang.Thread thread) {
+		this.thread = thread;
+		thread.setName(s);
+	}
+
+	@Override
+	public final boolean isActive() {
+		return thread.equals(java.lang.Thread.currentThread());
+	}
+
+	protected void routine() {
+		while (!java.lang.Thread.interrupted()) {
+			Task task;
+			synchronized (queue) {
+				if (queue.isEmpty()) {
+					try {
+						queue.wait();
+					} catch (InterruptedException ignored) {
+						break;
+					}
+					continue;
+				}
+				task = queue.peekFirst();
+				assert task != null;
+				if (task.moment > System.currentTimeMillis()) {
+					try {
+						queue.wait(task.moment - System.currentTimeMillis());
+					} catch (InterruptedException ignored) {
+						continue;
+					}
+					continue;
+				}
+				queue.pollFirst();
+			}
+			try {
+				task.run();
+			} catch (Exception e) {
+				log.error("error in thread: " + e);
+				e.printStackTrace();
+			}
+		}
+	}
+
+	protected void enqueueTask(Task task) {
+		synchronized (queue) {
+			ListIterator<Task> i = queue.listIterator();
+			while (i.hasNext()) {
+				Task t = i.next();
+				if (t.getMoment() > task.getMoment()) {
+					i.previous();
+					i.add(task);
+					task = null;
+					break;
+				}
+			}
+			if (task != null) {
+				queue.add(task);
+			}
+
+			/*
+			Iterator<Task> j = queue.iterator();
+			Task prev = null;
+			while (j.hasNext()) {
+				Task next = j.next();
+				assert (prev == null) || prev.getMoment() <= next.getMoment();
+				prev = next;
+			}
+			*/
+			queue.notify();
+		}
+	}
+
+	@Override
+	public void invokeLater(final Runnable runnable) {
+		if (!(runnable instanceof Task)) {
+			enqueueTask(new Task() {
+				@Override
+				public void run() {
+					runnable.run();
+				}
+			});
+			return;
+		}
+		enqueueTask((Task)runnable);
+	}
+
+	public void interrupt() {
+		thread.interrupt();
+	}
+
+	public void join() throws InterruptedException {
+		thread.join();
+	}
+
+	public void start() {
+		thread.start();
+	}
+
+	public void setName(String name) {
+		thread.setName(name);
+
+	}
+}
Index: java/main/src/main/java/com/framsticks/util/lang/Casting.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Casting.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/lang/Casting.java	(revision 84)
@@ -0,0 +1,31 @@
+package com.framsticks.util.lang;
+
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class Casting {
+    public static <T> T tryCast(Class<T> class_, Object object) {
+        try {
+            return class_.cast(object);
+        } catch (ClassCastException ignored) {
+            return null;
+        }
+    }
+
+    public static <T> T assertCast(Class<T> class_, Object object) {
+        try {
+            return class_.cast(object);
+        } catch (ClassCastException ignored) {
+            assert false;
+            return null;
+        }
+    }
+
+    public static <T> T throwCast(Class<T> class_, Object object) {
+        if (object == null) {
+            throw new NullPointerException();
+        }
+        return class_.cast(object);
+    }
+}
Index: java/main/src/main/java/com/framsticks/util/lang/Containers.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Containers.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/lang/Containers.java	(revision 84)
@@ -0,0 +1,41 @@
+package com.framsticks.util.lang;
+
+import java.util.Collection;
+import java.util.Iterator;
+import java.util.List;
+import org.apache.commons.collections.functors.InstanceofPredicate;
+import org.apache.commons.collections.iterators.FilterIterator;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class Containers {
+	public static void resizeList(List<?> list, int size) {
+		while (list.size() < size) {
+			list.add(null);
+		}
+		while (list.size() > size) {
+			list.remove(list.size() - 1);
+		}
+	}
+
+	@SuppressWarnings("unchecked")
+	public static <T> Iterable<T> filterInstanceof(Iterator<? super T> i, Class<T> type) {
+		return new IterableIterator<T>(new FilterIterator(i, new InstanceofPredicate(type)));
+	}
+
+	@SuppressWarnings("unchecked")
+	public static <T> Iterable<T> filterInstanceof(Iterable<? super T> i, Class<T> type) {
+		return new IterableIterator<T>(new FilterIterator(i.iterator(), new InstanceofPredicate(type)));
+	}
+
+	@SuppressWarnings("unchecked")
+	public static <T> Iterable<T> filterInstanceof(Collection<? super T> c, Class<T> type) {
+		return new IterableIterator<T>(new FilterIterator(c.iterator(), new InstanceofPredicate(type)));
+	}
+
+	// @SuppressWarnings("unchecked")
+	// public static <T> Iterable<T> filterNotInstanceof(Collection<T> c, Class<? extends T> type) {
+	// 	return new IterableIterator<T>(new FilterIterator(c.iterator(), new NotPredicate(new InstanceofPredicate(type))));
+	// }
+}
Index: java/main/src/main/java/com/framsticks/util/lang/Delimeted.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Delimeted.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/lang/Delimeted.java	(revision 84)
@@ -0,0 +1,38 @@
+package com.framsticks.util.lang;
+
+import org.apache.commons.collections.Closure;
+
+public class Delimeted implements Closure {
+
+	protected final String delimeter;
+	protected final String empty;
+	protected StringBuilder builder = null;
+
+	/**
+	 * @param delimeter
+	 */
+	public Delimeted(String delimeter, String empty) {
+		this.delimeter = delimeter;
+		this.empty = empty;
+	}
+
+	public final Delimeted append(Object object) {
+		if (builder != null) {
+			builder.append(delimeter);
+		} else {
+			builder = new StringBuilder();
+		}
+		builder.append(object);
+		return this;
+	}
+
+	public final String build() {
+		return (builder != null ? builder.toString() : empty);
+	}
+
+	@Override
+	public void execute(Object input) {
+		append(input);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/lang/Exceptions.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Exceptions.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/lang/Exceptions.java	(revision 84)
@@ -0,0 +1,15 @@
+package com.framsticks.util.lang;
+
+import java.io.PrintWriter;
+import java.io.StringWriter;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class Exceptions {
+	public static String printStackTrace(Throwable throwable) {
+		StringWriter w = new StringWriter();
+		throwable.printStackTrace(new PrintWriter(w));
+		return w.getBuffer().toString();
+	}
+}
Index: java/main/src/main/java/com/framsticks/util/lang/IterableIterator.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/IterableIterator.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/lang/IterableIterator.java	(revision 84)
@@ -0,0 +1,51 @@
+package com.framsticks.util.lang;
+
+import java.util.Iterator;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class IterableIterator<T> implements Iterable<T> {
+
+	protected final Iterator<T> i;
+
+	// private static <T> Iterator<T> createIterator(final Iterator<? extends T> i) {
+	//	return new Iterator<T>() {
+
+	//		@Override
+	//		public boolean hasNext() {
+	//			return i.hasNext();
+	//		}
+
+	//		@Override
+	//		public T next() {
+	//			return i.next();
+	//		}
+
+	//		@Override
+	//		public void remove() {
+	//			i.remove();
+	//		}
+	//	};
+	// }
+
+	@SuppressWarnings("unchecked")
+	public IterableIterator(Iterator<? extends T> i) {
+		this.i = (Iterator<T>) i;
+	}
+
+	// public IterableIterator(Iterator<? extends T> i) {
+	//	this.i = createIterator(i);
+	// }
+
+	public Iterator<T> iterator() {
+		return i;
+	}
+
+
+	// @SuppressWarnings("unchecked")
+	// public static <T> IterableIterator<T> unsafe(Iterator<?> i) {
+	//	return new IterableIterator<T>((Iterator<T>) i);
+	// }
+
+}
Index: java/main/src/main/java/com/framsticks/util/lang/Iterators.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Iterators.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/lang/Iterators.java	(revision 84)
@@ -0,0 +1,19 @@
+package com.framsticks.util.lang;
+
+// import java.util.Iterator;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class Iterators {
+
+
+	// public static String resolve(Iterator<?> iterator, String separator) {
+	// 	Delimeted d = new Delimeted(separator, "");
+	// 	while (iterator.hasNext()) {
+	// 		d.append(iterator.next());
+	// 	}
+	// 	return d.build();
+	// }
+
+}
Index: java/main/src/main/java/com/framsticks/util/lang/Numbers.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Numbers.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/lang/Numbers.java	(revision 84)
@@ -0,0 +1,47 @@
+package com.framsticks.util.lang;
+
+import java.lang.reflect.InvocationTargetException;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class Numbers {
+
+	@SuppressWarnings("unchecked")
+	public static <T extends Number> T parse(String value, Class<T> type) {
+		if (!Strings.notEmpty(value)) {
+			return null;
+		}
+		try {
+			return (T)type.getMethod("valueOf", String.class).invoke(null, value);
+		} catch (IllegalAccessException e) {
+			e.printStackTrace();
+		} catch (InvocationTargetException e) {
+			if (e.getTargetException() instanceof NumberFormatException) {
+				return null;
+			}
+			e.printStackTrace();
+		} catch (NoSuchMethodException e) {
+			e.printStackTrace();
+		} catch (NumberFormatException ignored) {
+			return null;
+		}
+		return null;
+	}
+
+
+
+	public static <T extends Number> T cast(Object value, Class<T> type) {
+		if (value == null) {
+			return null;
+		}
+		if (value instanceof String) {
+			return parse((String)value, type);
+		}
+		if (value.getClass() == type) {
+			return type.cast(value);
+		}
+		return null;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/lang/Pair.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Pair.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/lang/Pair.java	(revision 84)
@@ -0,0 +1,20 @@
+package com.framsticks.util.lang;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class Pair<T1, T2> {
+	public final T1 first;
+	public final T2 second;
+
+	public Pair(T1 first, T2 second) {
+		this.first = first;
+		this.second = second;
+	}
+
+	@Override
+	public String toString() {
+		return Strings.toStringNullProof(first) + " " + Strings.toStringNullProof(second);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/lang/Strings.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Strings.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/lang/Strings.java	(revision 84)
@@ -0,0 +1,44 @@
+package com.framsticks.util.lang;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class Strings {
+
+	public static String valueOf(Object o) {
+		if (o == null) {
+			return null;
+		}
+		return o.toString();
+	}
+
+	public static boolean notEmpty(String str) {
+		return str != null && !str.equals("");
+	}
+
+	public static String toStringNullProof(Object object) {
+		if (object == null) {
+			return "";
+		}
+		return object.toString();
+	}
+
+	public static String collapse(String s) {
+		if (s == null) {
+			return null;
+		}
+		s = s.trim();
+		return (s.equals("")) ? null : s;
+	}
+
+	public static Pair<String, String> splitIntoPair(String string, char separator, String second) {
+		int pos = string.indexOf(separator);
+		if (pos == -1) {
+			return new Pair<String, String>(string.substring(0,
+					string.length() - 1), second);
+		} else {
+			return new Pair<String, String>(string.substring(0, pos),
+					string.substring(pos + 1));
+		}
+	}
+}
Index: java/main/src/main/java/com/framsticks/util/math/Orientation.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/math/Orientation.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/math/Orientation.java	(revision 84)
@@ -0,0 +1,79 @@
+package com.framsticks.util.math;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class Orientation {
+	public final Point3d x;
+	public final Point3d y;
+	public final Point3d z;
+
+	public Orientation(Point3d x, Point3d y, Point3d z) {
+		this.x = x;
+		this.y = y;
+		this.z = z;
+	}
+
+	public Orientation() {
+		x = new Point3d(1, 0, 0);
+		y = new Point3d(0, 1, 0);
+		z = new Point3d(0, 0, 1);
+	}
+
+	/** based on c++ void Orient::transform(Pt3D& target,const Pt3D &s) const */
+	public Point3d transform(Point3d source) {
+		Point3d.Builder b = new Point3d.Builder();
+		for (int i = 0; i < 3; ++i) {
+			double v = 0;
+			for (int j = 0; j < 3; ++j) {
+				v += source.get(j) * this.get(j).get(i);
+			}
+			b.set(i, v);
+		}
+		return b.build();
+	}
+
+	/** based on c++ void Orient::transform(Orient& target,const Orient& src) const */
+	public Orientation transform(Orientation source) {
+		return new Orientation(transform(source.x), transform(source.y), transform(source.z));
+	}
+
+	protected static Point3d rotate2D(double sin, double cos, Point3d p, int a0, int a1, int im) {
+		Point3d.Builder b = new Point3d.Builder();
+		b.set(a0, cos * p.get(a0) - sin * p.get(a1));
+		b.set(a1, sin * p.get(a0) + cos * p.get(a1));
+		b.set(im, p.get(im));
+		return b.build();
+	}
+
+	/** based on c++ Orient::rotate(const Pt3D &v) */
+	public Orientation rotate(Point3d v) {
+		Point3d[] p = new Point3d[] {x, y, z};
+
+		for (int i = 0; i < 3; ++i) {
+			double sin = Math.sin(v.get(i));
+			double cos = Math.cos(v.get(i));
+
+			for (int j = 0; j < 3; ++j) {
+				p[j] = rotate2D(sin, cos, p[j], i == 0 ? 1 : 0, i == 2 ? 1 : 2, i);
+			}
+		}
+		return new Orientation(p[0], p[1], p[2]);
+	}
+
+	final Point3d get(int i) {
+		switch (i) {
+			case 0: return x;
+			case 1: return y;
+			case 2: return z;
+		}
+		assert false;
+		return null;
+	}
+
+
+	@Override
+	public final String toString() {
+		return x + " | " + y + " | " + z;
+	}
+}
Index: java/main/src/main/java/com/framsticks/util/math/Point3d.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/math/Point3d.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/math/Point3d.java	(revision 84)
@@ -0,0 +1,67 @@
+package com.framsticks.util.math;
+	
+/**
+ * The simple class which represent point in 3d space.
+ */
+public class Point3d
+{
+	public final double x;
+	public final double y;
+	public final double z;
+
+	public Point3d() {
+		x = 0.0;
+		y = 0.0;
+		z = 0.0;
+	}
+
+	public Point3d(double x, double y, double z) {
+		this.x = x;
+		this.y = y;
+		this.z = z;
+	}
+
+	public Point3d(Point3d p) {
+		x = p.x;
+		y = p.y;
+		z = p.z;
+	}
+
+	@Override
+	public final String toString() {
+		return x + " " + y + " " + z;
+	}
+
+	public final double get(int i) {
+		switch (i) {
+			case 0: return x;
+			case 1: return y;
+			case 2: return z;
+		}
+		assert false;
+		return 0;
+	}
+
+
+	public final Point3d add(Point3d p) {
+		return new Point3d(x + p.x, y + p.y, z + p.z);
+	}
+
+	public final Point3d sub(Point3d p) {
+		return new Point3d(x - p.x, y - p.y, z - p.z);
+	}
+
+	public final double length() {
+		return Math.sqrt(x * x + y * y + z * z);
+	}
+
+	public static class Builder {
+		double[] a = new double[3];
+
+		public Point3d build() { return new Point3d(a[0], a[1], a[2]); }
+
+		public final void set(int i, double v) {
+			a[i] = v;
+		}
+	}
+}
Index: java/main/src/main/java/com/framsticks/util/swing/KeyboardModifier.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/swing/KeyboardModifier.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/swing/KeyboardModifier.java	(revision 84)
@@ -0,0 +1,27 @@
+package com.framsticks.util.swing;
+
+import javax.swing.*;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class KeyboardModifier {
+	final InputMap inputMap;
+	final ActionMap actionMap;
+
+	public KeyboardModifier(JComponent component, int condition) {
+		inputMap = component.getInputMap(condition);
+		actionMap = component.getActionMap();
+	}
+
+	public KeyboardModifier join(KeyStroke newOne, KeyStroke oldOne) {
+		inputMap.put(newOne, inputMap.get(oldOne));
+		return this;
+	}
+
+	public KeyboardModifier add(KeyStroke keyStroke, String name, Action action) {
+		inputMap.put(keyStroke, name);
+		actionMap.put(name, action);
+		return this;
+	}
+}
Index: java/main/src/main/java/com/framsticks/util/swing/Layout.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/swing/Layout.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/swing/Layout.java	(revision 84)
@@ -0,0 +1,23 @@
+package com.framsticks.util.swing;
+
+
+import javax.swing.*;
+import java.awt.*;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class Layout {
+	public static void fixComponentSize(JComponent component, Dimension dimension) {
+		component.setPreferredSize(dimension);
+		component.setMaximumSize(dimension);
+		component.setMaximumSize(dimension);
+	}
+
+	public static void copyComponentDimensions(JComponent destination, JComponent source) {
+		destination.setPreferredSize(source.getPreferredSize());
+		destination.setMaximumSize(source.getMaximumSize());
+		destination.setMinimumSize(source.getMinimumSize());
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/swing/MenuConstructor.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/swing/MenuConstructor.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/swing/MenuConstructor.java	(revision 84)
@@ -0,0 +1,24 @@
+package com.framsticks.util.swing;
+
+import javax.swing.*;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class MenuConstructor {
+	protected final JMenu menu;
+
+	public MenuConstructor(JMenu menu) {
+		this.menu = menu;
+	}
+
+	public MenuConstructor add(KeyStroke accelerator, Action action) {
+		JMenuItem item = new JMenuItem(action);
+		if (accelerator != null) {
+			item.setAccelerator(accelerator);
+		}
+		menu.add(item);
+		return this;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/swing/TooltipConstructor.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/swing/TooltipConstructor.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/swing/TooltipConstructor.java	(revision 84)
@@ -0,0 +1,22 @@
+package com.framsticks.util.swing;
+
+public class TooltipConstructor {
+
+	protected final StringBuilder builder = new StringBuilder();
+
+	public TooltipConstructor() {
+		builder.append("<html>");
+	}
+
+	public final TooltipConstructor append(String header, Object value) {
+		if (value != null) {
+			builder.append(header).append(": ").append(value).append("<br/>");
+		}
+		return this;
+	}
+
+	public final String build() {
+		builder.append("</html>");
+		return builder.toString();
+	}
+}
Index: java/main/src/main/java/com/framsticks/util/swing/TreeNodeUtils.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/swing/TreeNodeUtils.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/swing/TreeNodeUtils.java	(revision 84)
@@ -0,0 +1,61 @@
+package com.framsticks.util.swing;
+
+import java.util.Iterator;
+
+import javax.swing.tree.DefaultTreeModel;
+import javax.swing.tree.MutableTreeNode;
+import javax.swing.tree.TreeNode;
+
+public final class TreeNodeUtils {
+
+	private TreeNodeUtils() {
+	}
+
+	public static class TreeNodeChildrenIterator implements Iterator<TreeNode> {
+
+		final TreeNode treeNode;
+		final DefaultTreeModel treeModel;
+		int index;
+
+		/**
+		 * @param treeNode
+		 * @param number
+		 */
+		public TreeNodeChildrenIterator(TreeNode treeNode, DefaultTreeModel treeModel) {
+			this.treeNode = treeNode;
+			this.treeModel = treeModel;
+			this.index = 0;
+		}
+
+		@Override
+		public boolean hasNext() {
+			return index < treeNode.getChildCount();
+		}
+
+		@Override
+		public TreeNode next() {
+			int i = index;
+			++index;
+			return (TreeNode) treeModel.getChild(treeNode, i);
+		}
+
+		@Override
+		public void remove() {
+			if (treeNode instanceof MutableTreeNode) {
+				((MutableTreeNode) treeNode).remove(index);
+				return;
+			}
+			throw new UnsupportedOperationException();
+		}
+	}
+
+	public static Iterable<TreeNode> children(final TreeNode treeNode, final DefaultTreeModel treeModel) {
+		return new Iterable<TreeNode>() {
+			@Override
+			public Iterator<TreeNode> iterator() {
+				return new TreeNodeChildrenIterator(treeNode, treeModel);
+			}
+		};
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/visualization/HelloUniverse2.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/HelloUniverse2.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/visualization/HelloUniverse2.java	(revision 84)
@@ -0,0 +1,85 @@
+/*
+ * $RCSfile: HelloUniverse.java,v $
+ *
+ * Copyright (c) 2007 Sun Microsystems, Inc. All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistribution of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ *
+ * - Redistribution in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in
+ *   the documentation and/or other materials provided with the
+ *   distribution.
+ *
+ * Neither the name of Sun Microsystems, Inc. or the names of
+ * contributors may be used to endorse or promote products derived
+ * from this software without specific prior written permission.
+ *
+ * This software is provided "AS IS," without a warranty of any
+ * kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
+ * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
+ * EXCLUDED. SUN MICROSYSTEMS, INC. ("SUN") AND ITS LICENSORS SHALL
+ * NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF
+ * USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
+ * DERIVATIVES. IN NO EVENT WILL SUN OR ITS LICENSORS BE LIABLE FOR
+ * ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
+ * CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
+ * REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
+ * INABILITY TO USE THIS SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGES.
+ *
+ * You acknowledge that this software is not designed, licensed or
+ * intended for use in the design, construction, operation or
+ * maintenance of any nuclear facility.
+ *
+ * $Revision: 1.2 $
+ * $Date: 2007/02/09 17:21:42 $
+ * $State: Exp $
+ */
+
+package com.framsticks.visualization;
+
+
+
+/**
+ * Simple Java 3D example program to display a spinning cube.
+ */
+@SuppressWarnings("serial")
+public class HelloUniverse2 extends javax.swing.JFrame {
+
+
+	/**
+	 * Creates new form HelloUniverse
+	 */
+	public HelloUniverse2() {
+		ViewerTest viewer = new ViewerTest();
+
+		setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
+		setTitle("HelloUniverse");
+
+		getContentPane().add(viewer, java.awt.BorderLayout.CENTER);
+
+		pack();
+
+	}
+
+	// ----------------------------------------------------------------
+
+
+	/**
+	 * @param args the command line arguments
+	 */
+	public static void main(String args[]) {
+		java.awt.EventQueue.invokeLater(new Runnable() {
+			public void run() {
+				new HelloUniverse2().setVisible(true);
+			}
+		});
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/visualization/ModelVisualizer.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/ModelVisualizer.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/visualization/ModelVisualizer.java	(revision 84)
@@ -0,0 +1,8 @@
+package com.framsticks.visualization;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class ModelVisualizer {
+
+}
Index: java/main/src/main/java/com/framsticks/visualization/SingleViewPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/SingleViewPanel.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/visualization/SingleViewPanel.java	(revision 84)
@@ -0,0 +1,42 @@
+package com.framsticks.visualization;
+
+import com.framsticks.gui.Panel;
+import com.framsticks.model.Model;
+import com.framsticks.params.AccessInterface;
+
+import javax.swing.*;
+import java.awt.*;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+@SuppressWarnings("serial")
+public class SingleViewPanel extends Panel {
+
+	Viewer viewer;
+
+	public SingleViewPanel(Panel.Parameters parameters) {
+		super(parameters);
+		//viewer = new Viewer();
+		this.setLayout(new BorderLayout());
+		//this.add(viewer.getViewComponent(), BorderLayout.CENTER);
+		this.add(new JLabel("test"), BorderLayout.PAGE_START);
+		this.add(new ViewerTest(), BorderLayout.CENTER);
+	}
+
+	@Override
+	public void pullValuesFromLocalToUser(AccessInterface access) {
+		Object object = access.getSelected();
+		if (!(object instanceof Model)) {
+			return;
+		}
+		// Model model = (Model)object;
+
+
+	}
+
+	@Override
+	public String getTitle() {
+		return "3D view";
+	}
+}
Index: java/main/src/main/java/com/framsticks/visualization/SingleViewPanelProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/SingleViewPanelProvider.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/visualization/SingleViewPanelProvider.java	(revision 84)
@@ -0,0 +1,17 @@
+package com.framsticks.visualization;
+
+import com.framsticks.gui.Panel;
+import com.framsticks.gui.PanelProvider;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class SingleViewPanelProvider implements PanelProvider {
+	@Override
+	public Panel providePanel(Panel.Parameters parameters) {
+		if (parameters.param.getContainedTypeName().equals("Model")) {
+			return new SingleViewPanel(parameters);
+		}
+		return null;
+	}
+}
